//
// USB-CDC Sample program "Hello world"
//

#include <stdlib.h>						// itoa()
#include <string.h>						// strcat()
#include "HardwareProfile.h"			// Local file
#include "usb_config.h"					//      :
#include "GenericTypeDefs.h"			// Microchip Application Libraries
#include "Compiler.h"					//              :
#include "USB/usb.h"					//              :
#include "USB/usb_device.h"				//              :
#include "USB/usb_function_cdc.h"		//              :

// PIC18F2550
//	#pragma config PLLDIV   = 1			// 4 MHz crystal
//	#pragma config PLLDIV   = 2			// 8 MHz crystal
	#pragma config PLLDIV   = 3			// 12 MHz crystal
//	#pragma config PLLDIV   = 4			// 16 MHz crystal
//	#pragma config PLLDIV   = 5			// 20 MHz crystal
//	#pragma config PLLDIV   = 6			// 24 MHz crystal
//	#pragma config PLLDIV   = 12		// 48 MHz crystal
	#pragma config CPUDIV   = OSC1_PLL2	// Primary oscillator direct or 96MHz PLL/2=48MHz
//	#pragma config CPUDIV   = OSC2_PLL3	// Primary oscillator/2 or 96MHz PLL/3=32MHz
//	#pragma config CPUDIV   = OSC3_PLL4	// Primary oscillator/3 or 96MHz PLL/4=24MHz
//	#pragma config CPUDIV   = OSC4_PLL6	// Primary oscillator/4 or 96MHz PLL/6=16MHz
//	#pragma config USBDIV   = 1			// Directly from the primary oscillator block with no postscale
	#pragma config USBDIV   = 2			// 96 MHz PLL divided by 2
//	#pragma config FOSC     = XT_XT		// XT oscillator, XT used by USB
//	#pragma config FOSC     = XTPLL_XT	// XT oscillator, PLL enabled, XT used by USB
//	#pragma config FOSC     = ECIO_EC	// External clock, port function on RA6, EC used by USB
//	#pragma config FOSC     = EC_EC		// External clock, CLKOUT on RA6, EC used by USB
//	#pragma config FOSC     = ECPLLIO_EC// External clock, PLL enabled, port function on RA6, EC used by USB
//	#pragma config FOSC     = ECPLL_EC	// External clock, PLL enabled, CLKOUT on RA6, EC used by USB
//	#pragma config FOSC     = INTOSCIO_EC// Internal oscillator, port function on RA6, EC used by USB
//	#pragma config FOSC     = INTOSC_EC	// Internal oscillator, CLKOUT on RA6, EC used by USB
//	#pragma config FOSC     = INTOSC_XT	// Internal oscillator, XT used by USB
//	#pragma config FOSC     = INTOSC_HS	// Internal oscillator, HS used by USB
//	#pragma config FOSC     = HS		// HS oscillator, HS used by USB
	#pragma config FOSC     = HSPLL_HS	// HS oscillator, PLL enabled, HS used by USB
//	#pragma config FCMEN    = ON		// Fail-Safe Clock Monitor enable
//	#pragma config IESO     = ON		// Oscillator Switchover mode enable
//	#pragma config PWRT     = ON		// Power-up Timer enable
//	#pragma config BOR      = OFF		// Brown-out Reset disable and on/off software control
	#pragma config BOR      = SOFT		// Brown-out Reset enable and on/off software control
//	#pragma config BOR      = ON_ACTIVE	// Brown-out Reset enable and disabled in Sleep mode
//	#pragma config BOR      = ON		// Brown-out Reset enable never
//	#pragma config BORV     = 0			// 4.59V(typ)
	#pragma config BORV     = 1			// 4.33V(typ)
//	#pragma config BORV     = 2			// 2.79V(typ)
//	#pragma config BORV     = 3			// 2.05V(typ)
	#pragma config VREGEN   = ON 		// USB Voltage Regulator enable
	#pragma config WDT      = OFF		// Watchdog Timer disable and on/off software control
	#pragma config WDTPS    = 2048		// 31kHz/128/<2048>=8.4sec
//	#pragma config CCP2MX   = OFF		// CCP2 = RB3 (ON=RC3)
//	#pragma config PBADEN   = OFF		// PORTB A/D disable
//	#pragma config LPT1OSC  = ON		// Low-Power Timer 1 Oscillator enable
	#pragma config MCLRE    = OFF		// RE3 enable
//	#pragma config STVREN   = OFF		// Stack full/underflow will cause Reset disable
//	#pragma config LVP      = OFF		// Single-Supply ICSP disable
	#pragma config XINST    = ON		// Extended Instruction Set enable
//	#pragma config DEBUG    = ON		// Background debugger enabled, RB6 and RB7 are dedicated to In-Circuit Debug
//	#pragma config CP0      = ON		// Block 0 (000800-001FFFh) is code-protected
//	#pragma config CP1      = ON		// Block 1 (002000-003FFFh) is code-protected
//	#pragma config CP2      = ON		// Block 2 (004000-005FFFh) is code-protected
//	#pragma config CP3      = ON		// Block 3 (006000-007FFFh) is code-protected
//	#pragma config CPB      = ON		// Boot block (000000-0007FFh) is code-protected
//	#pragma config CPD      = ON		// Data EEPROM is code-protected
//	#pragma config WRT0     = ON		// Block 0 (000800-001FFFh) or (001000-001FFFh) is write-protected
//	#pragma config WRT1     = ON		// Block 1 (002000-003FFFh) is write-protected
//	#pragma config WRT2     = ON		// Block 2 (004000-005FFFh) is write-protected
//	#pragma config WRT3     = ON		// Block 3 (006000-007FFFh) is write-protected
//	#pragma config WRTC     = ON		// Configuration registers (300000-3000FFh) are write-protected
	#pragma config WRTB     = ON		// Boot block (000000-0007FFh) is write-protected
//	#pragma config WRTD     = ON		// Data EEPROM is write-protected
//	#pragma config EBTR0    = ON		// Block 0 (000800-001FFFh) is protected from table reads executed in other blocks
//	#pragma config EBTR1    = ON		// Block 1 (002000-003FFFh) is protected from table reads executed in other blocks
//	#pragma config EBTR2    = ON		// Block 2 (004000-005FFFh) protected from table reads executed in other blocks
//	#pragma config EBTR3    = ON		// Block 3 (006000-007FFFh) protected from table reads executed in other blocks
//	#pragma config EBTRB    = ON		// Boot block (000000-0007FFh) is protected from table reads executed in other blocks

//
//	ISR
//
#pragma interrupt HISR
void HISR(){
	USBDeviceTasks();
}

#pragma interruptlow LISR
void LISR(){
}

//
//	Reset vector
//
#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)
	#define REMAPPED_RESET_VECTOR_ADDRESS			0x1000
	#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x1008
	#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x1018
#elif defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)	
	#define REMAPPED_RESET_VECTOR_ADDRESS			0x800
	#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x808
	#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x818
#else	
	#define REMAPPED_RESET_VECTOR_ADDRESS			0x00
	#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x08
	#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x18
#endif
	
#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)
	extern void _startup (void);        // See c018i.c in your C18 compiler dir
	#pragma code REMAPPED_RESET_VECTOR = REMAPPED_RESET_VECTOR_ADDRESS
	void _reset (void){
		_asm goto _startup _endasm
	}
#endif
	#pragma code REMAPPED_HIGH_INTERRUPT_VECTOR = REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS
	void Remapped_High_ISR (void){
	     _asm goto HISR _endasm
	}
	#pragma code REMAPPED_LOW_INTERRUPT_VECTOR = REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS
	void Remapped_Low_ISR (void){
	     _asm goto LISR _endasm
	}
#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)
	#pragma code HIGH_INTERRUPT_VECTOR = 0x08
	void High_ISR (void){
	     _asm goto REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS _endasm
	}
	#pragma code LOW_INTERRUPT_VECTOR = 0x18
	void Low_ISR (void){
	     _asm goto REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS _endasm
	}
#endif
#pragma code

//
//	USB callbacks
//
void USBCBSuspend(void){
}

void USBCBWakeFromSuspend(void){
}

void USBCB_SOF_Handler(void){
    // No need to clear UIRbits.SOFIF to 0 here.
    // Callback caller is already doing that.
}

void USBCBErrorHandler(void){
}

void USBCBCheckOtherReq(void){
    USBCheckCDCRequest();
}

void USBCBStdSetDscHandler(void){
    // Must claim session ownership if supporting this request
}

void USBCBInitEP(void){
    CDCInitEP();
}

void USBCBSendResume(void){
    static WORD delay_count;
    
    //First verify that the host has armed us to perform remote wakeup.
    //It does this by sending a SET_FEATURE request to enable remote wakeup,
    //usually just before the host goes to standby mode (note: it will only
    //send this SET_FEATURE request if the configuration descriptor declares
    //the device as remote wakeup capable, AND, if the feature is enabled
    //on the host (ex: on Windows based hosts, in the device manager 
    //properties page for the USB device, power management tab, the 
    //"Allow this device to bring the computer out of standby." checkbox 
    //should be checked).
    if(USBGetRemoteWakeupStatus() == TRUE) {
        //Verify that the USB bus is in fact suspended, before we send
        //remote wakeup signalling.
        if(USBIsBusSuspended() == TRUE) {
            USBMaskInterrupts();
            
            //Clock switch to settings consistent with normal USB operation.
            USBCBWakeFromSuspend();
            USBSuspendControl = 0; 
            USBBusIsSuspended = FALSE;  //So we don't execute this code again, 
                                        //until a new suspend condition is detected.

            //Section 7.1.7.7 of the USB 2.0 specifications indicates a USB
            //device must continuously see 5ms+ of idle on the bus, before it sends
            //remote wakeup signalling.  One way to be certain that this parameter
            //gets met, is to add a 2ms+ blocking delay here (2ms plus at 
            //least 3ms from bus idle to USBIsBusSuspended() == TRUE, yeilds
            //5ms+ total delay since start of idle).
            delay_count = 3600U;        
            do {
                delay_count--;
            } while(delay_count);
            
            //Now drive the resume K-state signalling onto the USB bus.
            USBResumeControl = 1;       // Start RESUME signaling
            delay_count = 1800U;        // Set RESUME line for 1-13 ms
            do{
                delay_count--;
            } while(delay_count);
            USBResumeControl = 0;       //Finished driving resume signalling

            USBUnmaskInterrupts();
        }
    }
}

#if defined(ENABLE_EP0_DATA_RECEIVED_CALLBACK)
void USBCBEP0DataReceived(void){
}
#endif

BOOL USER_USB_CALLBACK_EVENT_HANDLER(USB_EVENT event, void *pdata, WORD size){
    switch(event){
        case EVENT_TRANSFER:
            //Add application specific callback task or callback function here if desired.
            break;
        case EVENT_SOF:
            USBCB_SOF_Handler();
            break;
        case EVENT_SUSPEND:
            USBCBSuspend();
            break;
        case EVENT_RESUME:
            USBCBWakeFromSuspend();
            break;
        case EVENT_CONFIGURED: 
            USBCBInitEP();
            break;
        case EVENT_SET_DESCRIPTOR:
            USBCBStdSetDscHandler();
            break;
        case EVENT_EP0_REQUEST:
            USBCBCheckOtherReq();
            break;
        case EVENT_BUS_ERROR:
            USBCBErrorHandler();
            break;
        case EVENT_TRANSFER_TERMINATED:
            //Add application specific callback task or callback function here if desired.
            //The EVENT_TRANSFER_TERMINATED event occurs when the host performs a CLEAR
            //FEATURE (endpoint halt) request on an application endpoint which was 
            //previously armed (UOWN was = 1).  Here would be a good place to:
            //1.  Determine which endpoint the transaction that just got terminated was 
            //      on, by checking the handle value in the *pdata.
            //2.  Re-arm the endpoint if desired (typically would be the case for OUT 
            //      endpoints).
            break;
        default:
            break;
    }      
    return TRUE; 
}

//
//	Subroutines
//
void usb_puts(char *buf) {
	if(USB_BUS_SENSE && (USBGetDeviceState() == DETACHED_STATE)){
		USBDeviceAttach();
	}
	if ((USBDeviceState >= CONFIGURED_STATE) && (USBSuspendControl != 1)) {
		int i;

		for(i = 300; i > 0; --i) {
			if(mUSBUSARTIsTxTrfReady()) break;
			CDCTxService();
		}
		if (i > 0) {
 			putsUSBUSART(buf);
			CDCTxService();
		}
	}
	return;
}

//
//	main
//
void main(void){   
	char			buff[32];
	int				i;

	ADCON1 |= 0x0F;                 // Default all pins to digital

    USBDeviceInit();

   	for(i = 0; ; i++) {
		itoa(i, buff);
		strcatpgm2ram(buff, " Hello world.\r\n");
   	    usb_puts(buff);
	}

}//end main





